#!/usr/bin/python

import Numeric
import string
import sys
import LinearAlgebra

from Numeric import array, matrixmultiply, transpose, reshape
from LinearAlgebra import inverse, linear_least_squares
from gracePlot import gracePlot

from cij import *

def plotData( plot, dat, sym ):
    """Plot deformation data using grace"""
    
    eps=1e-6
    plot.multi(dat[0],6)
    for i in range(1,dat[0]+1):
        p, e, v=dat[i][0][0:3]
        m=inverse(array(dat[i][0][3]))
        s=array(dat[i][0][4])
#        print "\nM:",m,"\nS:", s
#        print p, e, v,"\n", m,"\n", s
        ul=[[],[],[],[],[],[]]
        sl=[[],[],[],[],[],[]]
        sv=0
        for k in range(1,len(dat[i])):
            d=dat[i][k][3]
            t=matrixmultiply(m,d)
            t=-(t+transpose(t))/2
            strain=(t[0][0],t[1][1],t[2][2],t[0][1],t[0][2],t[1][2])
#            print strain
            for l in range(0,6):
#                print abs(strain[l])
                if abs(strain[l])>eps : 
                    sv=strain[l]
#                    print sv
                    break
            stress=array(dat[i][k][4])-array([p,p,p,0,0,0])
            print "i:", i," k:", k, " l:",l," sv:",sv,"\n",strain,"\n",stress
            ul[l].append(sv)
            sl[l].append(stress[l])
            print ul,"\n"
            print sl
            plot.focus(i-1,1)
            plot.plot(ul,sl)

dat = ReadFile(sys.argv[1])
p = gracePlot()
p.title('Deformation data from: ' + sys.argv[1] + '.math.data')
plotData(p, dat, sys.argv[2]) 



#regular(uxx, uyy, uzz, uxy, uxz, uyz):
#cij=CalcCij( dat, eval(sys.argv[2]) )
#WriteOutResult(cij, sys.argv[1])


#print dat[0], dat[1][0][3]
